DefaultElement (Xerces2 Implementation)
Date: 2018-10-17

org.apache.xerces.impl.xs.opti

## Class DefaultElement

- java.lang.Object
- - org.apache.xerces.impl.xs.opti.DefaultNode
  - - org.apache.xerces.impl.xs.opti.NodeImpl
    - - org.apache.xerces.impl.xs.opti.DefaultElement

- All Implemented Interfaces:
    org.w3c.dom.Element, org.w3c.dom.Node
  Direct Known Subclasses:
    ElementImpl

      public class DefaultElement
      extends NodeImpl
      implements org.w3c.dom.Element

  Version:
    $Id: DefaultElement.java 699892 2008-09-28 21:08:27Z mrglavas $
  Author:
    Rahul Srivastava, Sun Microsystems Inc.

  # INTERNAL:

    Usage of this class is not supported. It may be altered or removed at any time.

- - ### Field Summary

    - ### Fields inherited from interface org.w3c.dom.Node

      `ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_PRECEDING, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DefaultElement()`
    `DefaultElement(java.lang.String prefix, java.lang.String localpart, java.lang.String rawname, java.lang.String uri, short nodeType)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getAttribute(java.lang.String name)` Retrieves an attribute value by name.
    `org.w3c.dom.Attr` | `getAttributeNode(java.lang.String name)` Retrieves an attribute node by name.
    `org.w3c.dom.Attr` | `getAttributeNodeNS(java.lang.String namespaceURI, java.lang.String localName)` Retrieves an `Attr` node by local name and namespace URI.
    `java.lang.String` | `getAttributeNS(java.lang.String namespaceURI, java.lang.String localName)` Retrieves an attribute value by local name and namespace URI.
    `org.w3c.dom.NodeList` | `getElementsByTagName(java.lang.String name)` Returns a `NodeList` of all descendant `Elements` with a given tag name, in document order.
    `org.w3c.dom.NodeList` | `getElementsByTagNameNS(java.lang.String namespaceURI, java.lang.String localName)` Returns a `NodeList` of all the descendant `Elements` with a given local name and namespace URI in document order.
    `org.w3c.dom.TypeInfo` | `getSchemaTypeInfo()` The type information associated with this element.
    `java.lang.String` | `getTagName()` The name of the element.
    `boolean` | `hasAttribute(java.lang.String name)` Returns `true` when an attribute with a given name is specified on this element or has a default value, `false` otherwise.
    `boolean` | `hasAttributeNS(java.lang.String namespaceURI, java.lang.String localName)` Returns `true` when an attribute with a given local name and namespace URI is specified on this element or has a default value, `false` otherwise.
    `void` | `removeAttribute(java.lang.String name)` Removes an attribute by name.
    `org.w3c.dom.Attr` | `removeAttributeNode(org.w3c.dom.Attr oldAttr)` Removes the specified attribute node.
    `void` | `removeAttributeNS(java.lang.String namespaceURI, java.lang.String localName)` Removes an attribute by local name and namespace URI.
    `void` | `setAttribute(java.lang.String name, java.lang.String value)` Adds a new attribute.
    `org.w3c.dom.Attr` | `setAttributeNode(org.w3c.dom.Attr newAttr)` Adds a new attribute node.
    `org.w3c.dom.Attr` | `setAttributeNodeNS(org.w3c.dom.Attr newAttr)` Adds a new attribute.
    `void` | `setAttributeNS(java.lang.String namespaceURI, java.lang.String qualifiedName, java.lang.String value)` Adds a new attribute.
    `void` | `setIdAttribute(java.lang.String name, boolean makeId)` If the parameter `isId` is `true`, this method declares the specified attribute to be a user-determined ID attribute .
    `void` | `setIdAttributeNode(org.w3c.dom.Attr at, boolean makeId)` If the parameter `isId` is `true`, this method declares the specified attribute to be a user-determined ID attribute .
    `void` | `setIdAttributeNS(java.lang.String namespaceURI, java.lang.String localName, boolean makeId)` If the parameter `isId` is `true`, this method declares the specified attribute to be a user-determined ID attribute .

    - ### Methods inherited from class org.apache.xerces.impl.xs.opti.NodeImpl

      `getLocalName, getNamespaceURI, getNodeName, getNodeType, getPrefix, getReadOnly, setReadOnly, toString`

    - ### Methods inherited from class org.apache.xerces.impl.xs.opti.DefaultNode

      `appendChild, cloneNode, compareDocumentPosition, getAttributes, getBaseURI, getChildNodes, getFeature, getFirstChild, getLastChild, getNextSibling, getNodeValue, getOwnerDocument, getParentNode, getPreviousSibling, getTextContent, getUserData, hasAttributes, hasChildNodes, insertBefore, isDefaultNamespace, isEqualNode, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, normalize, removeChild, replaceChild, setNodeValue, setPrefix, setTextContent, setUserData`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.w3c.dom.Node

      `appendChild, cloneNode, compareDocumentPosition, getAttributes, getBaseURI, getChildNodes, getFeature, getFirstChild, getLastChild, getLocalName, getNamespaceURI, getNextSibling, getNodeName, getNodeType, getNodeValue, getOwnerDocument, getParentNode, getPrefix, getPreviousSibling, getTextContent, getUserData, hasAttributes, hasChildNodes, insertBefore, isDefaultNamespace, isEqualNode, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, normalize, removeChild, replaceChild, setNodeValue, setPrefix, setTextContent, setUserData`

- - ### Constructor Detail

    - #### DefaultElement

          public DefaultElement()

    - #### DefaultElement

          public DefaultElement(java.lang.String prefix,
                                java.lang.String localpart,
                                java.lang.String rawname,
                                java.lang.String uri,
                                short nodeType)

  - ### Method Detail

    - #### getTagName

          public java.lang.String getTagName()

      Description copied from interface: `org.w3c.dom.Element`
      The name of the element. If `Node.localName` is different from `null`, this attribute is a qualified name. For example, in:

           <elementExample id="demo"> ...
           </elementExample> ,

      `tagName` has the value `"elementExample"`. Note that this is case-preserving in XML, as are all of the operations of the DOM. The HTML DOM returns the `tagName` of an HTML element in the canonical uppercase form, regardless of the case in the source HTML document.
      Specified by:
        `getTagName` in interface `org.w3c.dom.Element`

    - #### getAttribute

          public java.lang.String getAttribute(java.lang.String name)

      Description copied from interface: `org.w3c.dom.Element`
      Retrieves an attribute value by name.
      Specified by:
        `getAttribute` in interface `org.w3c.dom.Element`
      Parameters:
        `name` - The name of the attribute to retrieve.
      Returns:
        The `Attr` value as a string, or the empty string if that attribute does not have a specified or default value.

    - #### getAttributeNode

          public org.w3c.dom.Attr getAttributeNode(java.lang.String name)

      Description copied from interface: `org.w3c.dom.Element`
      Retrieves an attribute node by name.
      To retrieve an attribute node by qualified name and namespace URI, use the `getAttributeNodeNS` method.
      Specified by:
        `getAttributeNode` in interface `org.w3c.dom.Element`
      Parameters:
        `name` - The name (`nodeName`) of the attribute to retrieve.
      Returns:
        The `Attr` node with the specified name ( `nodeName`) or `null` if there is no such attribute.

    - #### getElementsByTagName

          public org.w3c.dom.NodeList getElementsByTagName(java.lang.String name)

      Description copied from interface: `org.w3c.dom.Element`
      Returns a `NodeList` of all descendant `Elements` with a given tag name, in document order.
      Specified by:
        `getElementsByTagName` in interface `org.w3c.dom.Element`
      Parameters:
        `name` - The name of the tag to match on. The special value "*" matches all tags.
      Returns:
        A list of matching `Element` nodes.

    - #### getAttributeNS

          public java.lang.String getAttributeNS(java.lang.String namespaceURI,
                                                 java.lang.String localName)

      Description copied from interface: `org.w3c.dom.Element`
      Retrieves an attribute value by local name and namespace URI.
      Per [XML Namespaces] , applications must use the value `null` as the `namespaceURI` parameter for methods if they wish to have no namespace.
      Specified by:
        `getAttributeNS` in interface `org.w3c.dom.Element`
      Parameters:
        `namespaceURI` - The namespace URI of the attribute to retrieve.
        `localName` - The local name of the attribute to retrieve.
      Returns:
        The `Attr` value as a string, or the empty string if that attribute does not have a specified or default value.

    - #### getAttributeNodeNS

          public org.w3c.dom.Attr getAttributeNodeNS(java.lang.String namespaceURI,
                                                     java.lang.String localName)

      Description copied from interface: `org.w3c.dom.Element`
      Retrieves an `Attr` node by local name and namespace URI.
      Per [XML Namespaces] , applications must use the value `null` as the `namespaceURI` parameter for methods if they wish to have no namespace.
      Specified by:
        `getAttributeNodeNS` in interface `org.w3c.dom.Element`
      Parameters:
        `namespaceURI` - The namespace URI of the attribute to retrieve.
        `localName` - The local name of the attribute to retrieve.
      Returns:
        The `Attr` node with the specified attribute local name and namespace URI or `null` if there is no such attribute.

    - #### getElementsByTagNameNS

          public org.w3c.dom.NodeList getElementsByTagNameNS(java.lang.String namespaceURI,
                                                             java.lang.String localName)

      Description copied from interface: `org.w3c.dom.Element`
      Returns a `NodeList` of all the descendant `Elements` with a given local name and namespace URI in document order.
      Specified by:
        `getElementsByTagNameNS` in interface `org.w3c.dom.Element`
      Parameters:
        `namespaceURI` - The namespace URI of the elements to match on. The special value "*" matches all namespaces.
        `localName` - The local name of the elements to match on. The special value "*" matches all local names.
      Returns:
        A new `NodeList` object containing all the matched `Elements`.

    - #### hasAttribute

          public boolean hasAttribute(java.lang.String name)

      Description copied from interface: `org.w3c.dom.Element`
      Returns `true` when an attribute with a given name is specified on this element or has a default value, `false` otherwise.
      Specified by:
        `hasAttribute` in interface `org.w3c.dom.Element`
      Parameters:
        `name` - The name of the attribute to look for.
      Returns:
        `true` if an attribute with the given name is specified on this element or has a default value, `false` otherwise.

    - #### hasAttributeNS

          public boolean hasAttributeNS(java.lang.String namespaceURI,
                                        java.lang.String localName)

      Description copied from interface: `org.w3c.dom.Element`
      Returns `true` when an attribute with a given local name and namespace URI is specified on this element or has a default value, `false` otherwise.
      Per [XML Namespaces] , applications must use the value `null` as the `namespaceURI` parameter for methods if they wish to have no namespace.
      Specified by:
        `hasAttributeNS` in interface `org.w3c.dom.Element`
      Parameters:
        `namespaceURI` - The namespace URI of the attribute to look for.
        `localName` - The local name of the attribute to look for.
      Returns:
        `true` if an attribute with the given local name and namespace URI is specified or has a default value on this element, `false` otherwise.

    - #### getSchemaTypeInfo

          public org.w3c.dom.TypeInfo getSchemaTypeInfo()

      Description copied from interface: `org.w3c.dom.Element`
      The type information associated with this element.
      Specified by:
        `getSchemaTypeInfo` in interface `org.w3c.dom.Element`

    - #### setAttribute

          public void setAttribute(java.lang.String name,
                                   java.lang.String value)
                            throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Element`
      Adds a new attribute. If an attribute with that name is already present in the element, its value is changed to be that of the value parameter. This value is a simple string; it is not parsed as it is being set. So any markup (such as syntax to be recognized as an entity reference) is treated as literal text, and needs to be appropriately escaped by the implementation when it is written out. In order to assign an attribute value that contains entity references, the user must create an `Attr` node plus any `Text` and `EntityReference` nodes, build the appropriate subtree, and use `setAttributeNode` to assign it as the value of an attribute.
      To set an attribute with a qualified name and namespace URI, use the `setAttributeNS` method.
      Specified by:
        `setAttribute` in interface `org.w3c.dom.Element`
      Parameters:
        `name` - The name of the attribute to create or alter.
        `value` - Value to set in string form.
      Throws:
        `org.w3c.dom.DOMException` - INVALID_CHARACTER_ERR: Raised if the specified name is not an XML name according to the XML version in use specified in the `Document.xmlVersion` attribute.
        NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

    - #### removeAttribute

          public void removeAttribute(java.lang.String name)
                               throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Element`
      Removes an attribute by name. If a default value for the removed attribute is defined in the DTD, a new attribute immediately appears with the default value as well as the corresponding namespace URI, local name, and prefix when applicable. The implementation may handle default values from other schemas similarly but applications should use `Document.normalizeDocument()` to guarantee this information is up-to-date.
      If no attribute with this name is found, this method has no effect.
      To remove an attribute by local name and namespace URI, use the `removeAttributeNS` method.
      Specified by:
        `removeAttribute` in interface `org.w3c.dom.Element`
      Parameters:
        `name` - The name of the attribute to remove.
      Throws:
        `org.w3c.dom.DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

    - #### removeAttributeNode

          public org.w3c.dom.Attr removeAttributeNode(org.w3c.dom.Attr oldAttr)
                                               throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Element`
      Removes the specified attribute node. If a default value for the removed `Attr` node is defined in the DTD, a new node immediately appears with the default value as well as the corresponding namespace URI, local name, and prefix when applicable. The implementation may handle default values from other schemas similarly but applications should use `Document.normalizeDocument()` to guarantee this information is up-to-date.
      Specified by:
        `removeAttributeNode` in interface `org.w3c.dom.Element`
      Parameters:
        `oldAttr` - The `Attr` node to remove from the attribute list.
      Returns:
        The `Attr` node that was removed.
      Throws:
        `org.w3c.dom.DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
        NOT_FOUND_ERR: Raised if `oldAttr` is not an attribute of the element.

    - #### setAttributeNode

          public org.w3c.dom.Attr setAttributeNode(org.w3c.dom.Attr newAttr)
                                            throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Element`
      Adds a new attribute node. If an attribute with that name ( `nodeName`) is already present in the element, it is replaced by the new one. Replacing an attribute node by itself has no effect.
      To add a new attribute node with a qualified name and namespace URI, use the `setAttributeNodeNS` method.
      Specified by:
        `setAttributeNode` in interface `org.w3c.dom.Element`
      Parameters:
        `newAttr` - The `Attr` node to add to the attribute list.
      Returns:
        If the `newAttr` attribute replaces an existing attribute, the replaced `Attr` node is returned, otherwise `null` is returned.
      Throws:
        `org.w3c.dom.DOMException` - WRONG_DOCUMENT_ERR: Raised if `newAttr` was created from a different document than the one that created the element.
        NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
        INUSE_ATTRIBUTE_ERR: Raised if `newAttr` is already an attribute of another `Element` object. The DOM user must explicitly clone `Attr` nodes to re-use them in other elements.

    - #### setAttributeNS

          public void setAttributeNS(java.lang.String namespaceURI,
                                     java.lang.String qualifiedName,
                                     java.lang.String value)
                              throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Element`
      Adds a new attribute. If an attribute with the same local name and namespace URI is already present on the element, its prefix is changed to be the prefix part of the `qualifiedName`, and its value is changed to be the `value` parameter. This value is a simple string; it is not parsed as it is being set. So any markup (such as syntax to be recognized as an entity reference) is treated as literal text, and needs to be appropriately escaped by the implementation when it is written out. In order to assign an attribute value that contains entity references, the user must create an `Attr` node plus any `Text` and `EntityReference` nodes, build the appropriate subtree, and use `setAttributeNodeNS` or `setAttributeNode` to assign it as the value of an attribute.
      Per [XML Namespaces] , applications must use the value `null` as the `namespaceURI` parameter for methods if they wish to have no namespace.
      Specified by:
        `setAttributeNS` in interface `org.w3c.dom.Element`
      Parameters:
        `namespaceURI` - The namespace URI of the attribute to create or alter.
        `qualifiedName` - The qualified name of the attribute to create or alter.
        `value` - The value to set in string form.
      Throws:
        `org.w3c.dom.DOMException` - INVALID_CHARACTER_ERR: Raised if the specified qualified name is not an XML name according to the XML version in use specified in the `Document.xmlVersion` attribute.
        NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
        NAMESPACE_ERR: Raised if the `qualifiedName` is malformed per the Namespaces in XML specification, if the `qualifiedName` has a prefix and the `namespaceURI` is `null`, if the `qualifiedName` has a prefix that is "xml" and the `namespaceURI` is different from " http://www.w3.org/XML/1998/namespace", if the `qualifiedName` or its prefix is "xmlns" and the `namespaceURI` is different from "http://www.w3.org/2000/xmlns/", or if the `namespaceURI` is "http://www.w3.org/2000/xmlns/" and neither the `qualifiedName` nor its prefix is "xmlns".
        NOT_SUPPORTED_ERR: May be raised if the implementation does not support the feature `"XML"` and the language exposed through the Document does not support XML Namespaces (such as [HTML 4.01]).

    - #### removeAttributeNS

          public void removeAttributeNS(java.lang.String namespaceURI,
                                        java.lang.String localName)
                                 throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Element`
      Removes an attribute by local name and namespace URI. If a default value for the removed attribute is defined in the DTD, a new attribute immediately appears with the default value as well as the corresponding namespace URI, local name, and prefix when applicable. The implementation may handle default values from other schemas similarly but applications should use `Document.normalizeDocument()` to guarantee this information is up-to-date.
      If no attribute with this local name and namespace URI is found, this method has no effect.
      Per [XML Namespaces] , applications must use the value `null` as the `namespaceURI` parameter for methods if they wish to have no namespace.
      Specified by:
        `removeAttributeNS` in interface `org.w3c.dom.Element`
      Parameters:
        `namespaceURI` - The namespace URI of the attribute to remove.
        `localName` - The local name of the attribute to remove.
      Throws:
        `org.w3c.dom.DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
        NOT_SUPPORTED_ERR: May be raised if the implementation does not support the feature `"XML"` and the language exposed through the Document does not support XML Namespaces (such as [HTML 4.01]).

    - #### setAttributeNodeNS

          public org.w3c.dom.Attr setAttributeNodeNS(org.w3c.dom.Attr newAttr)
                                              throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Element`
      Adds a new attribute. If an attribute with that local name and that namespace URI is already present in the element, it is replaced by the new one. Replacing an attribute node by itself has no effect.
      Per [XML Namespaces] , applications must use the value `null` as the `namespaceURI` parameter for methods if they wish to have no namespace.
      Specified by:
        `setAttributeNodeNS` in interface `org.w3c.dom.Element`
      Parameters:
        `newAttr` - The `Attr` node to add to the attribute list.
      Returns:
        If the `newAttr` attribute replaces an existing attribute with the same local name and namespace URI, the replaced `Attr` node is returned, otherwise `null` is returned.
      Throws:
        `org.w3c.dom.DOMException` - WRONG_DOCUMENT_ERR: Raised if `newAttr` was created from a different document than the one that created the element.
        NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
        INUSE_ATTRIBUTE_ERR: Raised if `newAttr` is already an attribute of another `Element` object. The DOM user must explicitly clone `Attr` nodes to re-use them in other elements.
        NOT_SUPPORTED_ERR: May be raised if the implementation does not support the feature `"XML"` and the language exposed through the Document does not support XML Namespaces (such as [HTML 4.01]).

    - #### setIdAttributeNode

          public void setIdAttributeNode(org.w3c.dom.Attr at,
                                         boolean makeId)
                                  throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Element`
      If the parameter `isId` is `true`, this method declares the specified attribute to be a user-determined ID attribute . This affects the value of `Attr.isId` and the behavior of `Document.getElementById`, but does not change any schema that may be in use, in particular this does not affect the `Attr.schemaTypeInfo` of the specified `Attr` node. Use the value `false` for the parameter `isId` to undeclare an attribute for being a user-determined ID attribute.
      Specified by:
        `setIdAttributeNode` in interface `org.w3c.dom.Element`
      Parameters:
        `at` - The attribute node.
        `makeId` - Whether the attribute is a of type ID.
      Throws:
        `org.w3c.dom.DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
        NOT_FOUND_ERR: Raised if the specified node is not an attribute of this element.

    - #### setIdAttribute

          public void setIdAttribute(java.lang.String name,
                                     boolean makeId)
                              throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Element`
      If the parameter `isId` is `true`, this method declares the specified attribute to be a user-determined ID attribute . This affects the value of `Attr.isId` and the behavior of `Document.getElementById`, but does not change any schema that may be in use, in particular this does not affect the `Attr.schemaTypeInfo` of the specified `Attr` node. Use the value `false` for the parameter `isId` to undeclare an attribute for being a user-determined ID attribute.
      To specify an attribute by local name and namespace URI, use the `setIdAttributeNS` method.
      Specified by:
        `setIdAttribute` in interface `org.w3c.dom.Element`
      Parameters:
        `name` - The name of the attribute.
        `makeId` - Whether the attribute is a of type ID.
      Throws:
        `org.w3c.dom.DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
        NOT_FOUND_ERR: Raised if the specified node is not an attribute of this element.

    - #### setIdAttributeNS

          public void setIdAttributeNS(java.lang.String namespaceURI,
                                       java.lang.String localName,
                                       boolean makeId)
                                throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Element`
      If the parameter `isId` is `true`, this method declares the specified attribute to be a user-determined ID attribute . This affects the value of `Attr.isId` and the behavior of `Document.getElementById`, but does not change any schema that may be in use, in particular this does not affect the `Attr.schemaTypeInfo` of the specified `Attr` node. Use the value `false` for the parameter `isId` to undeclare an attribute for being a user-determined ID attribute.
      Specified by:
        `setIdAttributeNS` in interface `org.w3c.dom.Element`
      Parameters:
        `namespaceURI` - The namespace URI of the attribute.
        `localName` - The local name of the attribute.
        `makeId` - Whether the attribute is a of type ID.
      Throws:
        `org.w3c.dom.DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
        NOT_FOUND_ERR: Raised if the specified node is not an attribute of this element.

Copyright © 1999-2010 The Apache Software Foundation. All Rights Reserved.